/* TABS4 */

#ifdef applix1616
/*
 * Handle IPC messages
 */

#include <syscalls.h>
#include <ipcblock.h>
#include <dde_ipc.h>
#include <sedit.h>

extern unsigned char *file_name;
extern int cur_lin;
extern int modflag;
extern int cur_y;
extern int top_lin;				/* Line number for line at top of screen */
extern int bot_lin;				/* Number of line beyond last displayed */

/* Signal handler */
ipcBlockPoll()
{
	IPCBLOCK *ip;
	dde_ipc *db;
	char buf[50];

	if (ip = (IPCBLOCK *)BLOCKRX(IPCB_FETCHNEXT))
	{
		db = (dde_ipc *)&ip->data[0];

		switch (db->mode)
		{
		case DDE_FILEANDLINE:
			if (strcmp(db->string, file_name))
			{	/* Different file */
				if (modflag)
					stringtome("\013d\r");		/* Write out current file */
				stringtome("\013n");			/* Switch files */
				stringtome(db->string);
				sendtome('\r');
				SPRINTF(buf, "\021g%d\r", db->lineno);
				stringtome(buf);				/* ^Qglineno\r */
			}
			else
			{	/* Same file */
				extern int height;
				int nmore = db->lineno - cur_lin;
				int dirn = nmore;

				if (nmore < 10 && nmore > -10)
				{
					while (nmore)
					{
						sendtome(nmore < 0 ? CTL('E') : CTL('X'));
						nmore += (nmore < 0) ? 1 : -1;
					}
					if (dirn < 0)
					{	/* Going up */
						if (cur_lin < top_lin - 3)
							sendtome(CTL('W'));
					}
					else
					{	/* Going down */
						if (cur_lin > bot_lin - 4)
							sendtome(CTL('Z'));
					}
				}
				else
				{
					SPRINTF(buf, "\021g%d\r", db->lineno);
					stringtome(buf);				/* ^Qglineno\r */
				}
			}
			stringtome("\013b\002\013k\002");		/* ^Kb^B^Kk^B */
			break;
		case DDE_COMMAND:
			stringtome(db->string);
			break;
		}
		FREEMEM(ip);
	}
}
#endif
