/* ex: set ts=4 sw=4: */

#include <stdio.h>
#include "../sedit.h"

/*
 * Patch any environment string substitutions in the
 * passed string.  Return a new, malloc'ed string
 */

char *_patchenv(char *in)
{
	char *cp, c;
	FILE *f;
	char *ret;

	cp = in;
	while (c = *cp)
	{
		if (c == '*' || c == '?' || c == '[' || c == ']' || c == '$')
			break;
		cp++;
	}

	if (!c)
	{
cantdo:
		return roomfor(in);
	}

	/* Use 'echo' */
	cp = Malloc(strlen(in) + 20);
	strcpy(cp, "echo ");
	strcat(cp, in);
	f = popen(cp, "r");
	Free(cp);
	if (f == (FILE *)0)
		goto cantdo;
	ret = cp = Malloc(1000);
	if (fgets(cp, 1000, f) == 0)
	{
		Free(cp);
		goto cantdo;
	}
	pclose(f);
	while (*cp && *cp != '\r' && *cp != '\n')
		cp++;
	*cp = '\0';
	return ret;
}

/*
 * New patchenv() fornt-end: use the .dderc search path
 * returns a malloced name
 */

char *ddercLookupFile();

char *
patchenv(name)
char *name;
{
	char *ret;
	char *newname = ddercLookupFile(name);
	ret = _patchenv(newname);
	Free(newname);
	return ret;
} 
